/* xaff - a cuddly aff to place on your desktop.    */
/* by Thomas Wiegert (sackgesicht@xaff.de)          */
/*                                                  */
/* based on Stefan Gustavson's xteddy        .      */
/* Copyright Stefan Gustavson, ISY-LiTH, 1994.      */
/* Internet email address: stefang@isy.liu.se       */

/* Xpm pixmap manipulation routines for color       */
/* and grayscale affs are from the Xpm library      */
/* by Arnaud Le Hors, lehors@sophia.inria.fr,       */
/* Copyright 1990-93 GROUPE BULL                    */

/* This is Xaff version 3.0         1998-08-11.     */

#define VERSION "xaff version 3.0 mit gaul"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/extensions/shape.h>
#include <X11/cursorfont.h>
#include <sys/times.h>

#include "xpm.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "xaff_icon.xbm"
#include "xaff_bw.xbm"
#include "xaff_mask.xbm"
#include "xaff0.xbm"
#include "xaff1.xbm"
#include "xaff2.xbm"
#include "xaff3.xbm"

#include "xpferd_bw.xbm"
#include "xpferd_mask.xbm"
#include "xpferd0.xbm"
#include "xpferd1.xbm"
#include "xpferd2.xbm"
#include "xpferd3.xbm"
#include "xpferd4.xbm"


#ifndef NOXPM
#include "xaff_color.xpm"
#include "xpferd_color.xpm"
#endif

#define ABS(a) ((a>0)?(a):(-(a)))
#define RAND 0x3FFFFFFF


static char *progname;
Display *display;
int screen_num;


#if (xaff_mask_height > xpferd_mask_height)
#define __height xaff_mask_height
#else
#define __height xpferd_mask_height
#endif

#if (xaff_mask_width > xpferd_mask_width)
#define __width xaff_mask_width
#else
#define __width xpferd_mask_width
#endif

char* _xaff_color[__height + 20];
char xpm_array[__height + 20][__width + 20];

char *xaff_bits[8] = { NULL, NULL, xaff0_bits, xaff1_bits,
                       xaff3_bits, xaff2_bits, NULL, NULL };
char *xpferd_bits[8] = { NULL, NULL, xpferd0_bits, xpferd1_bits,
                         xpferd3_bits, xpferd2_bits, xpferd4_bits, NULL };

typedef struct
{
 int width, height; /* bitmap sizes (pixels) */
 int bitmap_size;   /* bitmap sizes (bytes)  */
 char **bits, *src_bitmap, **src_pixmap, **dest_pixmap;
 int bw_width, bw_height;
 char *bw_bits;
} Viech;

Viech viecher[] = {
  {xaff_mask_width, xaff_mask_height, sizeof(xaff0_bits),
   xaff_bits, xaff_mask_bits, xaff_color, _xaff_color,
   xaff_bw_width, xaff_bw_height, xaff_bw_bits},
  {xpferd_mask_width, xpferd_mask_height, sizeof(xpferd0_bits),
   xpferd_bits, xpferd_mask_bits, xpferd_color, _xaff_color,
   xpferd_bw_width, xpferd_bw_height, xpferd_bw_bits} 
};

enum ViechIndex { AFF, PFERD, ZEBRA };
Viech* pViech = viecher;

#define AffMoveNotify 50

int AffOderGaul (int argc, char** argv)
{
 int viech_index = AFF;
 if (!strcasecmp(*argv + strlen (*argv) - strlen ("xpferd"), "xpferd"))
   viech_index = PFERD;
 else if (!strcasecmp(*argv + strlen (*argv) - strlen ("xzebra"), "xzebra"))
   viech_index = ZEBRA;
 else                                   viech_index = AFF;

 while (--argc) 
   {
      ++argv;
      /* Aeffle, monkey, singe, scimma */
      if (!strcmp(*argv, "-aff")) viech_index = AFF;
      else if (!strcmp(*argv, "-aeffle")) viech_index = AFF;
      else if (!strcmp(*argv, "-monkey")) viech_index = AFF;
      else if (!strcmp(*argv, "-mongele")) viech_index = AFF;
      else if (!strcmp(*argv, "-xaff")) viech_index = AFF;

      /* Pferdle, horse, cheval, cavallino */
      else if (!strcmp(*argv, "-pferd")) viech_index = PFERD;
      else if (!strcmp(*argv, "-pferdle")) viech_index = PFERD;
      else if (!strcmp(*argv, "-gaul")) viech_index = PFERD;
      else if (!strcmp(*argv, "-horse")) viech_index = PFERD;
      else if (!strcmp(*argv, "-horsele")) viech_index = PFERD;
      else if (!strcmp(*argv, "-xpferd")) viech_index = PFERD;

      /* Zebra, zebre */
      else if (!strcmp(*argv, "-zebra")) viech_index = ZEBRA;
      else if (!strcmp(*argv, "-xzebra")) viech_index = ZEBRA;
   }

 pViech = viecher + ((viech_index == AFF)? AFF: PFERD);
 return viech_index;
}


void InitPixmap (void)
{
 int n, nmax, ncolors, height, dummy;
 
 char **src, **dest;
 
 /* viech indepedent */
 for (n = 0; n < __height + 20; n++) _xaff_color[n] = xpm_array[n];

 src  =  pViech->src_pixmap;
 sscanf (*src," %d %d %d %d", &dummy, &height, &ncolors, &dummy);

 dest = pViech->dest_pixmap;

 for (n = ncolors + height + 1; n; n--)
   strcpy (*dest++, *src++);
}


void ChangeColor (int index, char* color)
{ 
 int n;
 char *ptr, *ptr1;

 if (!(strcasecmp(color, "transparent") &&
       strcasecmp(color, "none")))
        {
           if (pViech->bits[index] == NULL) return;
           for (n = pViech->bitmap_size, 
                ptr =  pViech->src_bitmap, ptr1 = pViech->bits[index]; 
                n; n--) *ptr++ &= *ptr1++; 
        }
 else
    {
       if (pViech->bits[index] != NULL)
          strcpy (xpm_array[index] + 4, color);
    }
}


void Wait (void)
{
 static struct timeval tv;
 tv.tv_sec = 0; tv.tv_usec = 100000;
 select (1, NULL, NULL, NULL, &tv);
}


void ChangeVelocity (float* vx, float* vy)
{
 float delta;
 int random_value;

 *vx += (float)(random() * 0.5 / (float)RAND - 0.25);
 *vy += (float)(random() * 0.5 / (float)RAND - 0.25);
}


int main(int argc, char** argv)
{
  /* Display, window and gc manipulation variables */
  Window win;
  GC gc;
  XSetWindowAttributes setwinattr;
  XGCValues gcvalues;
  unsigned long valuemask, gcvaluemask, inputmask;
  unsigned int width, height;
  int x, y, xPos = 0, yPos = 0, accel = False, dynamic = False,
      geomflags;
  unsigned int border_width = 0;
  unsigned int display_width, display_height, display_depth;
  unsigned int xmax, ymax;

  char *window_name = "Xaff";
  char *icon_name = "xaff";
  Pixmap icon_pixmap, background_pixmap, shape_pixmap;
  XSizeHints size_hints;
  XIconSize *size_list;
  XWMHints wm_hints;
  XClassHint class_hints;
  XTextProperty windowName, iconName;
  int count, argnum;
  int use_wm, float_up, use_mono;
  XEvent report;
  char *display_name = NULL;
  char buffer[20];
  int bufsize = 20;
  KeySym keysym;
  XComposeStatus compose;
  int charcount;
  Cursor cursor;
  
  float vx = 0, vy = 0;

#ifndef NOXPM
  /* Color allocation variables */
  Visual *default_visual;
  Colormap default_cmap;
  XpmAttributes xpmattributes;
  XVisualInfo *visual_info, vinfo_template;
  int viech;
  int nmatches;
  static char *visual_name[]={ "StaticGray", "GrayScale", "StaticColor",
				  "PseudoColor", "TrueColor", "DirectColor" };
#endif

  /* Window movement variables */
  XWindowChanges winchanges;
  Window root, child, basewin;
  int center = False, offs_x, offs_y, new_x, new_y, tmp_x, tmp_y;
  unsigned int tmp_mask;
  progname = argv[0];

  /* Option handling: "-w", "-f" "-mono" and "-geometry" are recognized */
  use_wm = False;
  float_up = False;
  use_mono = False;
  x = y = 0;
  geomflags = 0;

  viech = AffOderGaul (argc, argv);
  InitPixmap();

  if (viech == ZEBRA)
    {
      ChangeColor(3, "black");
      ChangeColor(2, "white");
      ChangeColor(4, "white");
    }

  for(argnum=1; argnum<argc; argnum++)
    {
      if (!strcmp(argv[argnum],"-w"))
	use_wm = True;
      else if (!strcmp(argv[argnum],"-f"))
	float_up = True;
      else if (!strcmp(argv[argnum],"-mono"))
	use_mono = True;
      else if (!strcmp(argv[argnum],"-acc"))
	dynamic = accel = True;
      else if (!strcmp(argv[argnum],"-geometry"))
	geomflags = XParseGeometry(argv[++argnum], &x, &y, &width, &height);
      else if (!strcmp(argv[argnum],"-display"))
       display_name = argv[++argnum];
      else if (!strcmp(argv[argnum],"-xicht"))
       ChangeColor(2, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-face"))
       ChangeColor(2, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-gosch"))
       ChangeColor(3, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-mouth"))
       ChangeColor(3, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-ohr"))
       ChangeColor(4, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-ear"))
       ChangeColor(4, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-aug"))
       ChangeColor(5, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-eye"))
       ChangeColor(5, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-hemd"))
       ChangeColor(6, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-shirt"))
       ChangeColor(6, argv[++argnum]);
      else if (!strcmp(argv[argnum],"-all"))
       {
        ChangeColor(2, argv[++argnum]);
        ChangeColor(3, argv[argnum]);
        ChangeColor(4, argv[argnum]);
        ChangeColor(5, argv[argnum]);
        ChangeColor(6, argv[argnum]);
       }
      else if (!strcmp(argv[argnum],"-center")) center = True;
      else if (!strcmp(argv[argnum],"-x")) xPos = atoi(argv[++argnum]);
      else if (!strcmp(argv[argnum],"-y")) yPos = atoi(argv[++argnum]);

      else if (!strcmp(argv[argnum],"-vx")) {
	vx = (float)atof(argv[++argnum]);
	dynamic = True;
	}
      else if (!strcmp(argv[argnum],"-vy")) {
	vy = (float)atof(argv[++argnum]);
	dynamic = True;
	}
    }
  
  /* Connect to X server */
  if ( (display = XOpenDisplay(display_name)) == NULL )
    {
      (void) fprintf(stderr, "%s: Cannot connect to X server %s\n",
		     progname, XDisplayName(display_name));
      exit(1);
    }
  /* Get screen size and depth */
  screen_num = DefaultScreen(display);
  display_width = DisplayWidth(display, screen_num);
  display_height = DisplayHeight(display, screen_num);

  xmax = display_width  - xaff_bw_width;
  ymax = display_height - xaff_bw_height;
  display_depth = DefaultDepth(display, screen_num);
  
  /* Set the window size to snugly fit the affbear pixmap */
  width = xaff_bw_width;
  height = xaff_bw_height;

  if (center)
   {
    xPos += xmax / 2;
    yPos += ymax / 2;
   }
  /* Create the main window */
  win = XCreateSimpleWindow(display, RootWindow(display,screen_num),
			    xPos,yPos,width,height,border_width,
			    BlackPixel(display,screen_num),
			    WhitePixel(display,screen_num));
  basewin = win;

  /* Create a GC (Currently not used for any drawing) */
  gcvalues.foreground = BlackPixel(display,screen_num);
  gcvalues.background = WhitePixel(display,screen_num);
  gcvaluemask = GCForeground | GCBackground;
  gc = XCreateGC(display, win, gcvaluemask, &gcvalues);

#ifdef NOXPM
  /* Use b/w dithered X bitmap no matter what */
  if (viech == AFF)
    background_pixmap =
      XCreatePixmapFromBitmapData(display, win, xaff_bw_bits,
  				xaff_bw_width, xaff_bw_height,
  				BlackPixel(display, screen_num),
  				WhitePixel(display, screen_num),
  				display_depth);
  else
    background_pixmap =
      XCreatePixmapFromBitmapData(display, win, xpferd_bw_bits,
  				xpferd_bw_width, xpferd_bw_height,
  				BlackPixel(display, screen_num),
  				WhitePixel(display, screen_num),
  				display_depth);
#else
  /* Get information about the default visual */
  default_visual = DefaultVisual(display, screen_num);
  default_cmap = DefaultColormap(display, screen_num);

  /* Get the visual class of the default visual. (I strongly feel */
  /* that there must be a more straightforward way to do this...) */
  vinfo_template.visualid = XVisualIDFromVisual(default_visual);
  visual_info = XGetVisualInfo(display, VisualIDMask,
			       &vinfo_template, &nmatches);
  /* The default visual should be supported, so don't check for NULL return */
#ifdef DEBUG
  printf("%s: default visual class is %s.\n",
	 progname, visual_name[visual_info->class]);
#endif
  if ((visual_info->class == StaticGray) || (use_mono))
    {
      /* Use b/w dithered bitmap */
	XCreatePixmapFromBitmapData(display, win, pViech->bw_bits,
				    pViech->bw_width, pViech->bw_height,
				    BlackPixel(display, screen_num),
				    WhitePixel(display, screen_num),
				    display_depth);
    }
  else /* at least GrayScale - let Xpm decide which visual to use */
    {
      xpmattributes.visual = default_visual;
      xpmattributes.colormap = default_cmap;
      xpmattributes.depth = display_depth;
      xpmattributes.valuemask = XpmVisual | XpmColormap | XpmDepth;

      if (XpmCreatePixmapFromData(display, win, _xaff_color,
				  &background_pixmap, &shape_pixmap,
				  &xpmattributes) < XpmSuccess)
	{
	  printf("%s: Failed to allocate colormap. Using black-and-white.\n",
		 progname);
	  background_pixmap =
	    XCreatePixmapFromBitmapData(display, win, xaff_bw_bits,
					xaff_bw_width, xaff_bw_height,
					BlackPixel(display, screen_num),
					WhitePixel(display, screen_num),
					display_depth);
	}
    }
  XFree(visual_info);
#endif
  setwinattr.background_pixmap = background_pixmap;
  if (use_wm)
    setwinattr.override_redirect = False;
  else
    setwinattr.override_redirect = True;
  cursor = XCreateFontCursor(display, XC_heart);
  setwinattr.cursor = cursor;
  valuemask = CWBackPixmap | CWOverrideRedirect | CWCursor;
  XChangeWindowAttributes(display, win, valuemask, &setwinattr);

  /* Create and set the shape pixmap of the window - requires shape Xext */
  shape_pixmap =
     XCreateBitmapFromData(display,win, pViech->src_bitmap,
                           pViech->width, pViech->height);

  XShapeCombineMask(display, win, ShapeBounding, 0, 0, shape_pixmap, ShapeSet);

  /* Get available icon sizes from window manager */
  /* (and then blatantly ignore the result)       */
  if (XGetIconSizes(display, RootWindow(display,screen_num),
		    &size_list, &count) == 0)
    {
      /* Window manager didn't set preferred icon sizes - use the default */
      icon_pixmap = XCreateBitmapFromData(display,win, xaff_icon_bits,
				      xaff_icon_width, xaff_icon_height);
    }
  else
    {
      /* Ignore the list and use the default size anyway */
      icon_pixmap = XCreateBitmapFromData(display,win, xaff_icon_bits,
				      xaff_icon_width, xaff_icon_height);
    }
  /* Report size hints and other stuff to the window manager */
  size_hints.min_width = width;    /* Don't allow any resizing */
  size_hints.min_height = height;
  size_hints.max_width = width;
  size_hints.max_height = height;
  size_hints.flags = PPosition | PSize | PMinSize | PMaxSize;
  if (XStringListToTextProperty(&window_name, 1, &windowName) == 0)
    {
      (void) fprintf(stderr,
		     "%s: structure allocation for windowName failed.\n",
		     progname);
      exit(1);
    }
  if (XStringListToTextProperty(&icon_name, 1, &iconName) == 0)
    {
      (void) fprintf(stderr,
		     "%s: structure allocation for iconName failed.\n",
		     progname);
      exit(1);
    }
  wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.icon_pixmap = icon_pixmap;
  wm_hints.flags = StateHint | IconPixmapHint | InputHint;
  
  class_hints.res_name = progname;
  class_hints.res_class = "Xaff";
  
  XSetWMProperties(display, win, &windowName, &iconName,
		   argv, argc, &size_hints, &wm_hints, &class_hints);

  /* Select event types wanted */
  inputmask = ExposureMask | KeyPressMask | ButtonPressMask | 
    ButtonReleaseMask | StructureNotifyMask | ButtonMotionMask | 
      PointerMotionHintMask | EnterWindowMask | LeaveWindowMask;
  if (float_up) inputmask |= VisibilityChangeMask;
  XSelectInput(display, win, inputmask);

  /* Display window */
  XMapWindow(display,win);

  /* Get and process the events */
  while (1)
    {
      static int IgnoreMotion = False;
      static int ButtonIsPressed = False;
    
      if (!ButtonIsPressed && dynamic)
       {
        if (XPending(display)) XNextEvent(display, &report);
        else { 	

                  Wait();
                  if (accel) ChangeVelocity (&vx, &vy);
                  report.type = AffMoveNotify;
                  xPos += vx; yPos += vy;
                  if ((xPos < 0) || (xPos > xmax)) vx = -vx;
                  if ((yPos < 0) || (yPos > ymax)) vy = -vy;
             }
       }
      else XNextEvent(display, &report);

      switch(report.type)
	{
	case Expose:
	  if (report.xexpose.count != 0)
	    break;
	  else
	    {
	      /* No drawing needed - the background pixmap */
	      /* is handled automatically by the X server  */
	    }
	  break;
	case ConfigureNotify:
	  /* Window has been resized */
	  width = report.xconfigure.width;
	  height = report.xconfigure.height;
	  break;
	case ReparentNotify:
	  /* Window was reparented by the window manager */
	  if (!use_wm)
	    (void) fprintf(stderr,
			   "%s: Window manager wouldn't leave window alone!\n",
			   progname);
	  basewin = report.xreparent.parent;
	  break;
	case EnterNotify:
	  /* Grab the keyboard while the pointer is in the window */
	  XGrabKeyboard(display, win, False, GrabModeAsync, GrabModeAsync,
			CurrentTime);
	  break;
	case LeaveNotify:
	  /* Release the keyboard when the pointer leaves the window */
	  XUngrabKeyboard(display, CurrentTime);
	  break;
	case ButtonPress:
	  /* Raise xaff above sibling windows  */
	  XRaiseWindow(display, win);
	  /* Remember where the mouse went down */
	  XQueryPointer(display, basewin, &root, &child, &tmp_x, &tmp_y,
			&offs_x, &offs_y, &tmp_mask);
          ButtonIsPressed = True;
	  break;
	case ButtonRelease:
	  /* Place xaff at the new position */
	  XQueryPointer(display, basewin, &root, &child, &new_x, &new_y,
		        &tmp_x, &tmp_y, &tmp_mask);
	  winchanges.x = new_x - offs_x;
	  winchanges.y = new_y - offs_y;
	  XReconfigureWMWindow(display, basewin, screen_num,
			       CWX | CWY, &winchanges);
          ButtonIsPressed = False;
	  break;
        case AffMoveNotify:
          /* Move xaff around with the mouse */
          winchanges.x = xPos;
          winchanges.y = yPos;
          XReconfigureWMWindow(display, win, screen_num,
                               CWX | CWY, &winchanges);
          IgnoreMotion = True;
          break;
	case MotionNotify:
	  /* Move xaff around with the mouse */
          if (!IgnoreMotion)
           {
    	    while (XCheckMaskEvent(display, ButtonMotionMask, &report));
	    if (!XQueryPointer(display, report.xmotion.window, &root, &child,
	  		      &new_x, &new_y, &tmp_x, &tmp_y, &tmp_mask))
	    break;
           }
          else IgnoreMotion = False;

	  xPos = winchanges.x = new_x - offs_x;
	  yPos = winchanges.y = new_y - offs_y;
	  XReconfigureWMWindow(display, win, screen_num,
			       CWX | CWY, &winchanges);
	  break;
	case VisibilityNotify:
	  /* Put xaff on top of overlapping windows */
	  if (float_up)
	    if ((report.xvisibility.state == VisibilityFullyObscured)
		|| (report.xvisibility.state == VisibilityPartiallyObscured))
	      XRaiseWindow(display,win);
	  break;
	case KeyPress:
	  /* Exit on "q" or "Q" */
	  charcount = XLookupString(&report.xkey, buffer, bufsize,
				    &keysym, &compose);
	  if((keysym == XK_Q) || (keysym == XK_q))
	    {
	      XCloseDisplay(display);
	      exit(0);
	    }
	  break;
	default:
	  /* Throw away all other events */
	  break;
	} /* end switch */
    } /* end while */
    return 0;
}
